Summary:       PKCS#11 interface for TPM 2.0 hardware
Name:          tpm2-pkcs11
Version: 1.9.0
Release: 3%{?dist}
License:       BSD
URL:           https://github.com/tpm2-software/tpm2-pkcs11
Source0:       %{url}/releases/download/%{version}/%{name}-%{version}.tar.gz

BuildRequires: gcc make python3 tpm2-tools python3-devel python3-setuptools python3-pyasn1-modules python3-pyyaml
BuildRequires: libgcrypt-devel libyaml-devel openssl-devel p11-kit-devel sqlite-devel tpm2-tss-devel tpm2-abrmd-devel
BuildRequires: python3-cryptography python3-tpm2-pytss
BuildRequires: libcmocka-devel dbus-daemon python3-bcrypt

%description
PKCS #11 is a Public-Key Cryptography Standard that defines a standard method to access cryptographic services
from tokens/ devices such as hardware security modules (HSM), smart cards, etc. In this project we intend to use
a TPM2 device as the cryptographic token.

%package tools
Summary: The tools required to setup and configure TPM2 for PKCS#11
Requires:    python3-cryptography python3-pyyaml python3-pyasn1-modules

%description tools
The tools required to setup and configure TPM2 for PKCS#11.

%prep
%autosetup -p1 -n %{name}-%{version}

%build
%configure \
    --enable-unit \
    %{nil}
%{make_build}
cd tools
%py3_build

%install
%make_install
rm -f %{buildroot}%{_libdir}/pkgconfig/tpm2-pkcs11.pc
rm -f %{buildroot}%{_libdir}/pkcs11/libtpm2_pkcs11.la
rm -f %{buildroot}%{_libdir}/pkcs11/libtpm2_pkcs11.a

cd tools
%py3_install
install -Dpm 755 tpm2_ptool %{buildroot}%{_bindir}/tpm2_ptool

%check
%make_build check
cd tools
%{__python3} setup.py test

%files
%license LICENSE
%{_datadir}/p11-kit/modules/tpm2_pkcs11.module
%%dir %{_libdir}/pkcs11
%{_libdir}/pkcs11/libtpm2_pkcs11.so
%{_libdir}/pkcs11/libtpm2_pkcs11.so.0*

%files tools
%{_bindir}/tpm2_ptool
%{python3_sitelib}/tpm2_pkcs11/*
%{python3_sitelib}/tpm2_pkcs11_tools-*/*

%changelog
* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.9.0-3
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.9.0-2
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Aug 18 2023 cunshunxia <cunshunxia@tencent.com> - 1.9.0-1
- upgrade to 1.9.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.8.0-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.8.0-3
- Rebuilt for OpenCloudOS Stream 23

* Mon Dec 26 2022 Shuo Wang <abushwang@tencent.com> - 1.8.0-2
- enable check

* Wed Dec 21 2022 Shuo Wang <abushwang@tencent.com> - 1.8.0-1
- initial build
